OGRE: Ogre::v1::GLES2DefaultHardwareVertexBuffer Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | List of all members
Ogre::v1::GLES2DefaultHardwareVertexBuffer Class Reference

Specialisation of HardwareVertexBuffer for emulation. More...

`#include <OgreGLES2DefaultHardwareBufferManager.h>`

Inheritance diagram for Ogre::v1::GLES2DefaultHardwareVertexBuffer:
[legend]

## Public Types
enum | LockOptions { HBL_NORMAL, HBL_DISCARD, HBL_READ_ONLY, HBL_NO_OVERWRITE, HBL_WRITE_ONLY }
| Locking options. More...
enum | Usage { HBU_STATIC = 1, HBU_DYNAMIC = 2, HBU_WRITE_ONLY = 4, HBU_DISCARDABLE = 8, HBU_STATIC_WRITE_ONLY = 5, HBU_DYNAMIC_WRITE_ONLY = 6, HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...

## Public Member Functions
| GLES2DefaultHardwareVertexBuffer (HardwareBufferManagerBase *mgr, size_t vertexSize, size_t numVertices, HardwareBuffer::Usage usage)
| GLES2DefaultHardwareVertexBuffer (size_t vertexSize, size_t numVertices, HardwareBuffer::Usage usage)
virtual | ~GLES2DefaultHardwareVertexBuffer ()
virtual void | _updateFromShadow (void)
| Updates the real buffer from the shadow buffer, if required. More...
virtual void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one. More...
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one. More...
void * | getDataPtr (size_t offset) const
size_t | getInstanceDataStepRate () const
| Get the number of instances to draw using the same per-instance data before advancing in the buffer by one element. More...
bool | getIsInstanceData () const
| Get if this vertex buffer is an "instance data" buffer (per instance) More...
HardwareBufferManagerBase * | getManager () const
| Return the manager of this buffer, if any. More...
size_t | getNumVertices (void) const
| Get the number of vertices in this buffer. More...
virtual void * | getRenderSystemData (void)
| An internal function that should be used only by a render system for internal use. More...
size_t | getSizeInBytes (void) const
| Returns the size of this buffer in bytes. More...
Usage | getUsage (void) const
| Returns the Usage flags with which this buffer was created. More...
size_t | getVertexSize (void) const
| Gets the size in bytes of a single vertex in this buffer. More...
bool | hasShadowBuffer (void) const
| Returns whether this buffer has a system memory shadow for quicker reading. More...
bool | isLocked (void) const
| Returns whether or not this buffer is currently locked. More...
bool | isSystemMemory (void) const
| Returns whether this buffer is held in system memory. More...
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing. More...
void * | lock (size_t offset, size_t length, LockOptions options)
| Override HardwareBuffer to turn off all shadowing. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
void | readData (size_t offset, size_t length, void *pDest)
| Reads data from the buffer and places it in the memory pointed to by pDest. More...
void | setInstanceDataStepRate (const size_t val)
| Set the number of instances to draw using the same per-instance data before advancing in the buffer by one element. More...
void | setIsInstanceData (const bool val)
| Set if this vertex buffer is an "instance data" buffer (per instance) More...
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes. More...
void | unlock (void)
| Override HardwareBuffer to turn off all shadowing. More...
void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough. More...

## Detailed Description

Specialisation of HardwareVertexBuffer for emulation.

## Member Enumeration Documentation

## ◆ LockOptions

enum Ogre::v1::HardwareBuffer::LockOptions
| inherited

Locking options.

Enumerator
HBL_NORMAL | Normal mode, ie allows read/write and contents are preserved.
HBL_DISCARD | Discards the entire buffer while locking; this allows optimisation to be performed because synchronisation issues are relaxed. Only allowed on buffers created with the HBU_DYNAMIC flag.
HBL_READ_ONLY | Lock the buffer for reading only. Not allowed in buffers which are created with HBU_WRITE_ONLY. Mandatory on static buffers, i.e. those created without the HBU_DYNAMIC flag.
HBL_NO_OVERWRITE | As HBL_DISCARD, except the application guarantees not to overwrite any region of the buffer which has already been used in this frame, can allow some optimisation on some APIs.
HBL_WRITE_ONLY | Lock the buffer for writing only.

## ◆ Usage

enum Ogre::v1::HardwareBuffer::Usage
| inherited

Enums describing buffer usage; not mutually exclusive.

Enumerator
HBU_STATIC | Static buffer which the application rarely modifies once created. Modifying the contents of this buffer will involve a performance hit.
HBU_DYNAMIC | Indicates the application would like to modify this buffer with the CPU fairly often. Buffers created with this flag will typically end up in AGP memory rather than video memory.
HBU_WRITE_ONLY | Indicates the application will never read the contents of the buffer back, it will only ever write data. Locking a buffer with this flag will ALWAYS return a pointer to new, blank memory rather than the memory associated with the contents of the buffer; this avoids DMA stalls because you can write to a new memory area while the previous one is being used.
HBU_DISCARDABLE | Indicates that the application will be refilling the contents of the buffer regularly (not just updating, but generating the contents from scratch), and therefore does not mind if the contents of the buffer are lost somehow and need to be recreated. This allows and additional level of optimisation on the buffer. This option only really makes sense when combined with HBU_DYNAMIC_WRITE_ONLY.
HBU_STATIC_WRITE_ONLY | Combination of HBU_STATIC and HBU_WRITE_ONLY.
HBU_DYNAMIC_WRITE_ONLY | Combination of HBU_DYNAMIC and HBU_WRITE_ONLY. If you use this, strongly consider using HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE instead if you update the entire contents of the buffer very regularly.
HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE | Combination of HBU_DYNAMIC, HBU_WRITE_ONLY and HBU_DISCARDABLE.

## Constructor & Destructor Documentation

## ◆ GLES2DefaultHardwareVertexBuffer() [1/2]

Ogre::v1::GLES2DefaultHardwareVertexBuffer::GLES2DefaultHardwareVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVertices,
|  | HardwareBuffer::Usage | usage
| ) |  |

## ◆ GLES2DefaultHardwareVertexBuffer() [2/2]

Ogre::v1::GLES2DefaultHardwareVertexBuffer::GLES2DefaultHardwareVertexBuffer | ( | HardwareBufferManagerBase * | mgr,
|  | size_t | vertexSize,
|  | size_t | numVertices,
|  | HardwareBuffer::Usage | usage
| ) |  |

## ◆ ~GLES2DefaultHardwareVertexBuffer()

virtual Ogre::v1::GLES2DefaultHardwareVertexBuffer::~GLES2DefaultHardwareVertexBuffer | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _updateFromShadow()

virtual void Ogre::v1::HardwareBuffer::_updateFromShadow | ( | void |  | ) |
| inlinevirtualinherited

Updates the real buffer from the shadow buffer, if required.

Reimplemented in Ogre::v1::MetalHardwareVertexBuffer, Ogre::v1::MetalHardwareIndexBuffer, Ogre::v1::GL3PlusHardwareVertexBuffer, Ogre::v1::GL3PlusHardwareIndexBuffer, and Ogre::v1::D3D11HardwareBuffer.

## ◆ copyData() [1/2]

virtual void Ogre::v1::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer | ) |
| inlinevirtualinherited

Copy all data from another buffer into this one.

Remarks
  Normally these buffers should be of identical size, but if they're not, the routine will use the smallest of the two sizes.

References Ogre::v1::HardwareBuffer::getSizeInBytes(), and Ogre::min().

## ◆ copyData() [2/2]

virtual void Ogre::v1::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer,
|  | size_t | srcOffset,
|  | size_t | dstOffset,
|  | size_t | length,
|  | bool | discardWholeBuffer = `false`
| ) |  |
| inlinevirtualinherited

Copy data from another buffer into this one.

Remarks
  Note that the source buffer must not be created with the usage HBU_WRITE_ONLY otherwise this will fail.

Parameters

  srcBuffer | The buffer from which to read the copied data
  srcOffset | Offset in the source buffer at which to start reading
  dstOffset | Offset in the destination buffer to start writing
  length | Length of the data to copy, in bytes.
  discardWholeBuffer | If true, will discard the entire contents of this buffer before copying

Reimplemented in Ogre::v1::MetalHardwareVertexBuffer, Ogre::v1::MetalHardwareIndexBuffer, Ogre::v1::GLES2HardwareUniformBuffer, Ogre::v1::GL3PlusHardwareVertexBuffer, Ogre::v1::GL3PlusHardwareUniformBuffer, Ogre::v1::GL3PlusHardwareShaderStorageBuffer, Ogre::v1::GL3PlusHardwareIndexBuffer, Ogre::v1::GL3PlusHardwareCounterBuffer, Ogre::v1::D3D11HardwareVertexBuffer, Ogre::v1::D3D11HardwareUniformBuffer, Ogre::v1::D3D11HardwareIndexBuffer, and Ogre::v1::D3D11HardwareBuffer.

References Ogre::v1::HardwareBuffer::lock(), and Ogre::v1::HardwareBuffer::unlock().

## ◆ getDataPtr()

void* Ogre::v1::GLES2DefaultHardwareVertexBuffer::getDataPtr | ( | size_t | offset | ) | const
| inline

## ◆ getRenderSystemData()

virtual void* Ogre::v1::HardwareBuffer::getRenderSystemData | ( | void |  | ) |
| inlinevirtualinherited

An internal function that should be used only by a render system for internal use.

Reimplemented in Ogre::v1::MetalHardwareVertexBuffer, and Ogre::v1::MetalHardwareIndexBuffer.

## ◆ getSizeInBytes()

size_t Ogre::v1::HardwareBuffer::getSizeInBytes | ( | void |  | ) | const
| inlineinherited

Returns the size of this buffer in bytes.

Referenced by Ogre::v1::HardwareBuffer::copyData().

## ◆ getUsage()

Usage Ogre::v1::HardwareBuffer::getUsage | ( | void |  | ) | const
| inlineinherited

Returns the Usage flags with which this buffer was created.

## ◆ hasShadowBuffer()

bool Ogre::v1::HardwareBuffer::hasShadowBuffer | ( | void |  | ) | const
| inlineinherited

Returns whether this buffer has a system memory shadow for quicker reading.

## ◆ isLocked()

bool Ogre::v1::HardwareBuffer::isLocked | ( | void |  | ) | const
| inlineinherited

Returns whether or not this buffer is currently locked.

References Ogre::v1::HardwareBuffer::isLocked().

Referenced by Ogre::v1::HardwareBuffer::isLocked(), and Ogre::v1::HardwareBuffer::unlock().

## ◆ isSystemMemory()

bool Ogre::v1::HardwareBuffer::isSystemMemory | ( | void |  | ) | const
| inlineinherited

Returns whether this buffer is held in system memory.

## ◆ lock() [1/2]

void* Ogre::v1::HardwareBuffer::lock | ( | LockOptions | options | ) |
| inlineinherited

Lock the entire buffer for (potentially) reading / writing.

Parameters

  options | Locking options

Returns
  Pointer to the locked memory

## ◆ lock() [2/2]

void* Ogre::v1::GLES2DefaultHardwareVertexBuffer::lock | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options
| ) |  |
| virtual

Override HardwareBuffer to turn off all shadowing.

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ readData()

void Ogre::v1::GLES2DefaultHardwareVertexBuffer::readData | ( | size_t | offset,
|  | size_t | length,
|  | void * | pDest
| ) |  |
| virtual

Reads data from the buffer and places it in the memory pointed to by pDest.

Parameters

  offset | The byte offset from the start of the buffer to read
  length | The size of the area to read, in bytes
  pDest | The area of memory in which to place the data, must be large enough to accommodate the data!

Implements Ogre::v1::HardwareBuffer.

## ◆ suppressHardwareUpdate()

void Ogre::v1::HardwareBuffer::suppressHardwareUpdate | ( | bool | suppress | ) |
| inlineinherited

Pass true to suppress hardware upload of shadow buffer changes.

## ◆ unlock()

void Ogre::v1::GLES2DefaultHardwareVertexBuffer::unlock | ( | void |  | ) |
| virtual

Override HardwareBuffer to turn off all shadowing.

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ writeData()

void Ogre::v1::GLES2DefaultHardwareVertexBuffer::writeData | ( | size_t | offset,
|  | size_t | length,
|  | const void * | pSource,
|  | bool | discardWholeBuffer = `false`
| ) |  |
| virtual

Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

Parameters

  offset | The byte offset from the start of the buffer to start writing
  length | The size of the data to write to, in bytes
  pSource | The source of the data to be written
  discardWholeBuffer | If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can.

Implements Ogre::v1::HardwareBuffer.

The documentation for this class was generated from the following file:

- OgreGLES2DefaultHardwareBufferManager.h